/* getvslice */
/* extract plane from E3D volume file (includes header) */

#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>

#define XY    1
#define XZ    2
#define YZ    3

/*
#define XDIM 328
#define YDIM 328
#define ZDIM 210
#define XDIM  50
#define YDIM  50
#define ZDIM  50
*/

main(argc, argv)
int argc;
char **argv;
{
   float *array, *plane, *line;
   int i, j, k, m, n, size, dplane, nplane;
   int xdim, ydim, zdim;
   int dummy;
   FILE *file;

   /* determine usage */
   if (argc != 4) {
      fprintf(stderr, "Usage: getvslice filename dplane nplane > outPlane\n");
      fprintf(stderr, "       dplane: 1=XY; 2=XZ; 3=YZ\n");
      exit(-1);
      }

   /* get input parameters */
   if (!(file = fopen(argv[1], "r"))) {
      fprintf(stderr, "Error: can't open file \"%s\"\n", argv[1]);
      exit(-1);
      };

   dplane = atoi(argv[2]);
   nplane = atoi(argv[3]);

   /* read file and get header parameters */
   fread(&xdim , sizeof(int), 1, file);
   fread(&ydim , sizeof(int), 1, file);
   fread(&zdim , sizeof(int), 1, file);
   fread(&dummy, sizeof(int), 1, file);
   fread(&dummy, sizeof(int), 1, file);
   fread(&dummy, sizeof(int), 1, file);
   fread(&dummy, sizeof(int), 1, file);
   fread(&dummy, sizeof(int), 1, file);
   fread(&dummy, sizeof(int), 1, file);
   fseek(file, 0, 0);
   
   if (dplane == XY) {size = xdim*ydim; n = xdim; m = ydim;}
   if (dplane == XZ) {size = xdim*zdim; n = xdim; m = zdim;}
   if (dplane == YZ) {size = ydim*zdim; n = ydim; m = zdim;}

   array = (float *) malloc(xdim*zdim*sizeof(float));
   plane = (float *) malloc(size     *sizeof(float));
   line  = (float *) malloc(xdim     *sizeof(float));

   /* read header */
   /*
   for(i = 0; i < 9; i++) fread(&dummy, sizeof(int), 1, file);
   */

   /* extract xz plane (YPLANE) */
   if (dplane == XZ) {
      fseek(file, 9*sizeof(int), 0);
      fseek(file, nplane*4*size, 1);
      fread(plane, 4, xdim*zdim, file);
      }

   /* extract xy plane (ZPLANE) */
   if (dplane == XY) {
      for(k = 0; k < ydim; k++) {
         fseek(file, 9*sizeof(int), 0);
         fseek(file, k*xdim*zdim*4 + nplane*xdim*4, 1);
         fread(line , 4, xdim, file);
         for(i = 0; i < xdim; i++) plane[k*xdim + i] = line[i];
         }
      }

   /* extract yz plane (XPLANE) */
   if (dplane == YZ) {
      for(k = 0; k < ydim; k++) {
         fread(array, 4, xdim*zdim, file);
         for(j = 0; j < zdim; j++) plane[j*ydim + k] = array[nplane + xdim*j];
         }
      }

   /* write header */
   fwrite(&n, 4, 1, stdout);
   fwrite(&m, 4, 1, stdout);

   /* write image plane */
   fwrite(plane, 4, size, stdout);

   free(plane);
   free(array);
   free(line );

   fclose(file);

}

