/* 
writesac: convert ascii list into sac file
compile: cc -g -o writesac wsac.c writesac.c -lm (mv wsac writesac)
usage: writesac delta < ascii_file > sac_file
*/

#include <stdio.h>
#include <math.h>
#include <stdlib.h>

#define N   1000000
#define DX  1.5

main(int argc, char **argv)
{
   float delta, y[N];
   int i, n;
   char line[82];

   /* print usage */
   if (argc != 2) {
      fprintf(stderr, "Usage: writesac delta < ascii_file > sac_file\n");
      exit(-1);
      }

   /* initialize */
   delta = (float) atof(argv[1]);
   n     = 0;

   /* read ascii list */
   while(fgets(line, 82, stdin) != NULL) {
      if (n == N) {
         fprintf(stderr, "Error: too many points (%d)\n", n + 1);
         exit(-1);
         }
      sscanf(line, "%f", y + n++);
      }

   /* output sac file */
   writeSAC(y, n, delta, stdout);

}

