

/*   history:

   20 DEC 1996   AJL   Original version. (converted from mcsyn6.c)
   coordinates changed:  MA (1/14/97)
   vel grid input changed to 3d: (1/22/97)
*/

#define PVER  "1.00"
#define PDATE "DEC 1996"

#define PI 3.14159265358979


/****************************************************************
CHANGE TO POLY3D.H AND COMBINE GETVEL1.H AND GETMOD.H
#include "getvel1.h"
****************************************************************/
#include "poly3d.h"
#include<stdio.h>
#include<sys/file.h>

FILE *fopen(), *outfile,*infile, *fp_input;
int fp,fs,fd;
double pvel,svel,density;
double alat,along,zloc;
float q1,q2,q3;


int ppoint(vp,vs,rho,qp,qs,qw,lon0,lat0,depth,file)
float *vp,*vs,*rho;
float *qp,*qs,*qw;
double lat0,lon0,depth;
FILE *file;
{

   /* shawn add (error on tera) */
   fp_input = file;
   

    
    strcpy(progver, PVER);
    strcpy(progdate, PDATE);



      /* check command line and open files */

      /* set constants */

   pi = 4. * atan(1.);
   rpd = pi /180.;
   c111 = 111.195;
        alat=lat0;
        along=lon0;
        zloc=depth;


   /*outfile=fopen("model.grid","w");*/






      /* read control input */

   if (read_input(fp_input))
      puterr("ppoint:  Error reading input file.");

              
/*  shawn
   fprintf(stderr,"\nElement Types:  1 - Layer, 2 - Polygon, 3 - Solid\n");
*/
   get_vel_request();
        
        *vp=(float)pvel;
        *vs=(float)svel;
        *rho=(float)density;
        *qp=q1;
        *qs=q2;
        *qw=q3;
        *qw *= 2.*(PI);
        if (*qs == -1.) *qs = *qp;
   return (0);

}

puterr(pm)
char *pm;
{
    fprintf(stderr, "%s: %s\n", progname, pm);
}



/* function to read input file */

int read_input(fp_input)
 FILE *fp_input;
{
    int n;
    int istat, iscan;
/*
   char param[10];
*/
   char param[258];
   char *line6;


   line6 = line + 5;

      /* open input file */

/*    if ((fp_input = fopen( fn_input, "r")) == NULL) {
      fprintf(stderr, "ppoint: Error - Cannot open model file.\n");
      istat = -1;
      exit(-1);
    }
*/
      /* read each input line */



   while (fgets(line, MAXLINE, fp_input) != NULL) { 




      istat = -1;

       if ((iscan = sscanf(line, "%s", param)) < 0 )
         continue;      /* read parmeter line */

      if (strncmp(param, "#", 1) == 0 ||
            strncmp(param, "\n", 1) == 0)   /* skip comment line */
         istat = 0;

      if (strncmp(param, "COMM", 4) == 0)      /* read param comment */
         if ((istat = get_comm(line6)) < 0)
            fprintf(stderr, "ppoint:  Error reading comment.\n");

      if (strncmp(param, "CONTROL", 6) == 0) /* read control params */
         if ((istat = get_control(line6 + 2)) < 0) 
            fprintf(stderr,
               "ppoint:  Error reading control params.\n");

      if (strncmp(param, "CUTOFF", 7) == 0)   /* read cutoff params */
          if ((istat = get_cutoff(line6 + 3)) < 0)
            fprintf(stderr, "ppoint:  Error reading cutoff parameters.\n");

      if (strncmp(param, "TRANS", 5) == 0)   /* read transform params */
          if ((istat = get_transform(line6 + 1)) < 0)
            fprintf(stderr, "ppoint:  Error reading transform parameters.\n");


         /* velocity model input */

      if (strncmp(param, "LAYER", 5) == 0) {   /* read layer desc */
          if ((istat = get_model_layer(model_layer, num_layers, line6 + 1)) < 0)
            fprintf(stderr, "ppoint:  Error reading model layer.\n");
         num_layers += istat;
      }

      if (strncmp(param, "ROUGH", 5) == 0) {   /* read rough bndry desc */
          if ((istat = get_model_rough(model_rough, num_rough,
            line6 + 1, fp_input)) < 0)
            fprintf(stderr,
               "ppoint:  Error reading model rough layer.\n");
         num_rough += istat;
      }

      if (strncmp(param, "DISK", 4) == 0) {   /* read disk desc */
          if ((istat = get_model_disk(model_disk, num_disks, line6)) < 0)
            fprintf(stderr, "ppoint:  Error reading disk model.\n");
         num_disks += istat;
      }

      if (strncmp(param, "SPHERE", 6) == 0) {   /* read disk desc */
          if ((istat = get_model_sphere(model_sphere,
               num_spheres, line6 + 2)) < 0)
            fprintf(stderr, "ppoint:  Error reading sphere model.\n");
         num_spheres += istat;
      }

      if (strncmp(param, "VERTEX", 6) == 0)   /* read vertex */
         if ((istat = get_model_vertex(line6 + 2)) < 0) 
            fprintf(stderr, "ppoint:  Error reading vertex.\n");

      if (strncmp(param, "EDGE", 4) == 0)   /* read edge */
         if ((istat = get_model_edge(line6)) < 0) 
            fprintf(stderr, "ppoint:  Error reading edge.\n");

      if (strncmp(param, "POLYGON2", 8) == 0)   /* read polygon */
         if ((istat = get_model_poly(line6 + 4, fp_input)) < 0) 
            fprintf(stderr, "ppoint:  Error reading 2D polygon.\n");

      if (strncmp(param, "POLYGON3", 8) == 0)   /* read polygon */
         if ((istat = get_model_poly_3d(line6 + 4, fp_input)) < 0) 
            fprintf(stderr, "ppoint:  Error reading 3D polygon.\n");

      if (strncmp(param, "SOLID", 5) == 0)   /* read polygon */
         if ((istat = get_model_solid(line6 + 1, fp_input)) < 0) 
            fprintf(stderr, "ppoint:  Error reading solid.\n");


      if (istat < 0) {
         fprintf(stderr, "ppoint:  Error reading input model: %s\n", line);
         return (istat);
      }

   }
   
   return (0);
}



/*** function to read comment line fom input line ***/

get_comm(inline1)
char *inline1;
{
   char *temp;

   temp = comment;

   while ((*temp++ = *inline1++) != '\0')     /* copy comment */
      ;

/* shawn */
    /*fprintf(stderr, "%s", comment);*/                    /* print comment line */

   return(0);
}


/*** function to read control params ***/

int get_control(line1)           
char *line1;
{
    sscanf(line1, "%d %d", &prog_mode_3d,&coord_sys);

/*   shawn
    fprintf(stderr,
"CONTROL:  prog_mode_3d=%d coordinates=%d\n",
      prog_mode_3d,coord_sys);
*/

   return(0);

}

/** function to read cutoff params */

int get_cutoff(inline1)
char *inline1;

{
   int istat;
   double vx1,vx2,vx3,vx4,vy1,vy2,vy3,vy4;

   if(coord_sys) {
     
   istat = sscanf(inline1, "%lf %lf %lf %lf %lf %lf",
      &min_x_cut, &max_x_cut, &min_y_cut, &max_y_cut,
      &min_z_cut, &max_z_cut);

      }
   else
     {   
   istat = sscanf(inline1, "%lf %lf %lf %lf %lf %lf",
      &min_lon_cut, &max_lon_cut, &min_lat_cut, &max_lat_cut,
      &min_z_cut, &max_z_cut);

        latlon2grid(min_lat_cut,min_lon_cut,&vx1,&vy1);
   latlon2grid(min_lat_cut,max_lon_cut,&vx2,&vy2);
   latlon2grid(max_lat_cut,max_lon_cut,&vx3,&vy3);
   latlon2grid(max_lat_cut,min_lon_cut,&vx4,&vy4);

   if(vy1<=vy2)
     min_y_cut=vy1;
   else
     min_y_cut=vy2;

   if(vx2>=vx3)
     max_x_cut=vx2;
   else
     max_x_cut=vx3;

   if(vy3>=vy4)
     max_y_cut=vy3;
   else
     max_y_cut=vy4;

   if(vx1<=vx4)
     min_x_cut=vx1;
   else
     min_x_cut=vx4;
      }
   
       
   fprintf(stderr,"CUTOFF  X=%.2lf->%.2lf   Y=%.2lf->%.2lf   Z=%.2lf->%.2lf\n",
      min_x_cut, max_x_cut, min_y_cut, max_y_cut, min_z_cut, max_z_cut);

   return(0);
}




/*** function to read map transformation parameters from input line ***/

get_transform(inline1)
char *inline1;
{

    double angle;

      /* read transform input line */

    sscanf(inline1, "%lf %lf %lf",
      &map_orig_lat, &map_orig_long, &map_rot);

/* shawn
   fprintf(stderr,"TRANSFORM  lat_cent %f  long_cent %f  rot %f\n",
      map_orig_lat, map_orig_long, map_rot);
*/

   angle = rpd * map_rot;
   cosang = cos(angle);
   sinang = sin(angle);

    return (0);
}


/** function to find velocity and density at a location */

int get_vel_request()
{

          int istat, imodel;
   double xloc,yloc,den;
   double qp, qs, qw;

   latlon2grid(alat, along, &xloc, &yloc);


   pvel = get_vel(xloc, yloc, zloc, 'P', &den, 1, &qp, &qs, &qw, &imodel); 
   svel = get_vel(xloc, yloc, zloc, 'S', &den, 1, &qp, &qs, &qw, &imodel);

   density=den;

/*  Set attenuation parameters to -1 at present*/
/*
   q1=-1.0;
   q2=-1.0;
   q3=-1.0;
*/

/* Set attenuation parameters */
   q1 = qp;
   q2 = qs;
   q3 = qw;

/*   fp=open("model.pvel",O_WRONLY | O_CREAT | O_TRUNC,0644);
   fs=open("model.svel",O_WRONLY | O_CREAT | O_TRUNC,0644);
   fd=open("model.den",O_WRONLY | O_CREAT | O_TRUNC,0644);
*/

/*fprintf(outfile,"%.4lf  %.4lf  %.4lf  %.4lf  %.4lf  %.4lf\n",alat, along, zloc
      ,pvel, svel, density);

   write(fp,(float)pvel,4);
   write(fs,(float)svel,4);
   write(fd,(float)density,4);
*/
   return(1);

}


/** function to convert lat/long to rectangular km grid */

int latlon2grid(xlat, xlong, pxgrid, pygrid)
double xlat, xlong, *pxgrid, *pygrid;
{

   double xtemp, ytemp;

   xtemp = (xlong - map_orig_long)
                  * c111 * cos(rpd * xlat);
   ytemp = (xlat - map_orig_lat) * c111;
   *pxgrid = xtemp * cosang + ytemp * sinang;
   *pygrid = ytemp * cosang - xtemp * sinang;
   return(0);

}

double get_vel(xpos, ypos, zpos, wavetype, den, idensity, qp, qs, qw, imodel)   
double xpos, ypos, zpos;
double *den;
char wavetype;
int idensity;
int *imodel;
double *qp, *qs, *qw;
{
   int iden;

    double vel;

   iden = (den != NULL && idensity) ? 1 : 0;

   if (num_spheres < 1 || 
      (vel = get_sphere_vel(xpos, ypos, zpos, wavetype, model_sphere,
         num_spheres, den, iden)) < 0.0) {
      if (num_disks < 1 || 
         (vel = get_disk_vel(xpos, zpos, wavetype, model_disk, 
            num_disks, den, iden)) < 0.0) {
         if ((prog_mode_3d && (num_solid < 1 || 
            (vel = get_solid_vel(xpos, ypos, zpos, wavetype,
            den, iden, qp, qs, qw, imodel)) < 0.0)) ||
            (! prog_mode_3d && (num_poly < 1 || 
            (vel = get_poly_vel(xpos, zpos, wavetype,
               den, iden, imodel)) < 0.0))) {
            if (num_rough < 1 || 
               (vel = get_rough_vel(xpos, zpos,
               wavetype, model_rough,
               num_rough, den, iden)) < 0.0) {
                if (fdgrid_flag < 1) 
                {
                   vel = get_layer_vel(zpos, 
                  wavetype, model_layer,
                   num_layers, den,
                  iden, qp, qs, qw, imodel);
                }
            }
         }
      }
   }

   return(vel); 
}
/* function to calculate velocity from gradient layer model */
 
double get_layer_vel(depth, wavetype, pm, nlayer, den, iden, qp, qs, qw, imodel)
double depth;
double *den;
char wavetype;
struct layer *pm;
int nlayer;

int iden;
int *imodel;
double *qp, *qs, *qw;
{
    int n;
    double vel;

        /* reflect point above surface */

    if (depth < 0.0)
      depth = -depth;

          /* Skip to layer containing depth */

    for (n = 0; n < nlayer-1 && depth >= (pm+n+1)->dtop; n++)
   ;

         /* calculate velocity */

    if (wavetype == 'P')
      vel = (pm+n)->vptop + (pm+n)->vpgrad * (depth - (pm+n)->dtop);
   else
      vel = (pm+n)->vstop + (pm+n)->vsgrad * (depth - (pm+n)->dtop);

         /* Calculate density */

    if (iden == 1)
      *den = (pm+n)->dentop + (pm+n)->dengrad * (depth - (pm+n)->dtop);

   /* calculate attenuation */
   *qp = (pm+n)->qpref;
   *qs = (pm+n)->qsref;
   *qw = (pm+n)->qwref;

      /* set model element code */

   *imodel = LAYEROFFSET + n;

    return(vel);
}


/* function to calculate velocity from disk model */
 
double get_disk_vel(xpos, zpos, wavetype, pd, ndisk, den, iden)  
double xpos, zpos;
double *den;
char wavetype;
struct disk *pd;
int ndisk;

int iden;
{
    int n;
   double xtemp, ztemp;

    double vel = -1.0;
   
    if (zpos > 0.0)
      zpos = -zpos;     /* reflect point above surface */

    for (n = 0; n < ndisk; n++) {      /* check if pos is in each disk */
      xtemp = xpos - (pd+n)->x;
      ztemp = zpos - (pd+n)->z;
      if (((xtemp * xtemp) + (ztemp * ztemp)) <= (pd+n)->rad2) {
          if (wavetype == 'P')
            vel = (pd+n)->pvel;
         else
            vel = (pd+n)->svel;
            if (iden == 1)
            *den = (pd+n)->den;
         break;
      }
   }

    return(vel);
}


/* function to calculate velocity from rough layer model */
 
double get_rough_vel(xpos, zpos, wavetype, pr, nrough, den, iden)  
double xpos, zpos;
double *den;   
char wavetype;
struct rough_bndry *pr;
int nrough;

int iden;
{
    int n;
    double vel = -1.0;

    if (zpos < 0.0)
      zpos = -zpos;     /* reflect point above surface */

      /* check if zpos is above each bndry */

    for (n = nrough - 1; n >= 0; n--) {
      if (zpos > (pr+n)->zmin && zpos > get_rough_z(n, xpos)) {
          if (wavetype == 'P')
            vel = (pr+n)->vptop +
               (pr+n)->vpgrad * (zpos - (pr+n)->ref_lev);
         else
            vel = (pr+n)->vstop +
               (pr+n)->vsgrad * (zpos - (pr+n)->ref_lev);
          if (iden == 1)
            *den = (pr+n)->dentop +
               (pr+n)->dengrad * (zpos - (pr+n)->ref_lev);
         break;
      }
   }

    return(vel);
}


/* function to calculate velocity from sphere model */
 
double get_sphere_vel(xpos, ypos, zpos, wavetype, pd, nsphere, den,iden)  
double xpos, ypos, zpos;
    double *den;   
char wavetype;
struct sphere *pd;
int nsphere;

int iden;
{
    int n;
   double xtemp, ytemp, ztemp;
    double vel = -1.0;

    if (zpos > 0.0)
      zpos = -zpos;     /* reflect point above surface */

    for (n = 0; n < nsphere; n++) {      /* check if pos is in each sphere */
      xtemp = xpos - (pd+n)->x;
      ytemp = ypos - (pd+n)->y;
      ztemp = zpos - (pd+n)->z;
      if (((xtemp * xtemp) + (ytemp * ytemp) + (ztemp * ztemp))
            <= (pd+n)->rad2) {
          if (wavetype == 'P')
            vel = (pd+n)->pvel;
         else
            vel = (pd+n)->svel;
            if (iden == 1)
            *den = (pd+n)->den;
         break;
      }
   }

    return(vel);
}


/* function to read disk inclusions  from input file */

int get_model_disk(pd, ndisk, inline1)
struct disk *pd;
int ndisk;
char *inline1;

{
   int n;
   double rad;

   n = ndisk;



   sscanf(inline1,
         "%lf %lf %lf %lf %lf %lf", &(pd+n)->x, &(pd+n)->z, &rad,
      &(pd+n)->pvel, &(pd+n)->svel, &(pd+n)->den);
      (pd+n)->rad2 = rad * rad;
      
    return (1);
}


/* function to read sphere inclusion  from input file */

int get_model_sphere(pd, nsphere, inline1)
struct sphere *pd;
int nsphere;
char *inline1;

{
   int n;
   double rad;
   double templon,templat;
   n = nsphere;

   if(coord_sys)
     {
   sscanf(inline1,
         "%lf %lf %lf %lf %lf %lf %lf", &(pd+n)->z, &(pd+n)->x, &(pd+n)->y,
      &rad, &(pd+n)->pvel, &(pd+n)->svel, &(pd+n)->den);
      (pd+n)->rad2 = rad * rad;
      }
   else
    {
/* change the following  3-1-00 (add the &)
      sscanf(inline1,
         "%lf %lf %lf %lf %lf %lf %lf", &(pd+n)->z, &templon, templat,
      &rad, &(pd+n)->pvel, &(pd+n)->svel, &(pd+n)->den);
*/
      sscanf(inline1,
         "%lf %lf %lf %lf %lf %lf %lf", &(pd+n)->z, &templon, &templat,
      &rad, &(pd+n)->pvel, &(pd+n)->svel, &(pd+n)->den);
      (pd+n)->rad2 = rad * rad;
      latlon2grid(templon,templat, &(pd+n)->x, &(pd+n)->y);
      }

   
    return (1);
}


/* function to read model layer from input file */

int get_model_layer(pm, nlayer, inline1)
struct layer *pm;
int nlayer;
char *inline1;
{
   int n;

   n = nlayer;

/*
*/
   (pm+n)->qpref = -1.;
   (pm+n)->qsref = -1.;
   (pm+n)->qwref = -1.;
/*
*/
   (pm+n)->plot = 1;
/*
   sscanf(inline1, "%lf %lf %lf %lf %lf %lf %lf %d",
      &(pm+n)->dtop, &(pm+n)->vptop, &(pm+n)->vpgrad,
      &(pm+n)->vstop, &(pm+n)->vsgrad, &(pm+n)->dentop, &(pm+n)->dengrad,
      &(pm+n)->plot);
*/
   sscanf(inline1, "%lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %d",
      &(pm+n)->dtop, &(pm+n)->vptop, &(pm+n)->vpgrad,
      &(pm+n)->vstop, &(pm+n)->vsgrad, &(pm+n)->dentop, &(pm+n)->dengrad,
      &(pm+n)->qpref, &(pm+n)->qsref, &(pm+n)->qwref,
      &(pm+n)->plot);

    return (1);
}


/*** function to read model rough layer from input file */

int get_model_rough(pm, nrough, inline1, fp)
struct rough_bndry *pm;
int nrough;
char *inline1;
FILE *fp;
{
   int n, nsin;

   n = nrough;

      /* read layer description */

   (pm+n)->plot = 1;
   sscanf(inline1, "%lf %lf %lf %lf %lf %lf %lf %d %d",
      &(pm+n)->ref_lev, &(pm+n)->vptop, &(pm+n)->vpgrad,
      &(pm+n)->vstop, &(pm+n)->vsgrad, &(pm+n)->dentop, &(pm+n)->dengrad,
      &(pm+n)->num_sin, &(pm+n)->plot);

      /* read each sinusoid description */

   for (nsin = 0; nsin < (pm+n)->num_sin; nsin++)
      if ((fscanf(fp, "%lf %lf %lf", &(pm+n)->amp[nsin],
         &(pm+n)->wavelen[nsin], &(pm+n)->phase[nsin])) != 3)
             return (-1);

    return (1);
}


/*** function to set approx max and min range of rough boundary */

set_rough_limits(pr)
struct rough_bndry *pr;
{
   int nrough;
   double x, xmin, xmax, dx;
   double roughmin, roughmax, ztest;

   for(nrough = 0; nrough < num_rough; nrough++) {

      xmin = min_x_cut;
      xmax = max_x_cut;
      dx = (xmax - xmin) / 10000.0;
      roughmin = roughmax = (pr+nrough)->ref_lev;

      for (x = xmin; x < xmax + dx; x += dx) {
         if ((ztest = get_rough_z(nrough, x)) < roughmin)
            roughmin = ztest;
         if (ztest > roughmax)
            roughmax = ztest;
      }

      (pr+nrough)->zmin = roughmin;
      (pr+nrough)->zmax = roughmax;

   }
}
      


/*** function to get rough boundary z level */

double get_rough_z(nrough, x)
int nrough;
double x;
{
   int nsin;
   double z;
   struct rough_bndry *rp;

   rp = &model_rough[nrough];

   z = rp->ref_lev;

   for (nsin = 0; nsin < rp->num_sin; nsin++) {
      z += (rp->amp[nsin] / 2.0) *
         sin(2.0 * pi * (x - rp->phase[nsin]) / rp->wavelen[nsin]);
   }

   return(z);
}



/*** function to read model vertices from input file */

int get_model_vertex(inline1)
char *inline1;
{
   int ident;
   double x, y, z;
   double lat,lon;
   struct vertex *vtxaddr;

   if(coord_sys)
     {
       if ((sscanf(inline1, "%d %lf %lf %lf", &ident, &z, &x, &y)) != 4)
           return (-1);

      }
   else
     {
       if ((sscanf(inline1, "%d %lf %lf %lf", &ident, &z, &lon, &lat)) != 4)
           return (-1);

       latlon2grid(lat,lon,&x,&y);
     }

     
   if ((vtxaddr = addvtx(ident)) == NULL)
       return (-2);
   num_vtx++;
   vtxaddr->id_vtx = ident;
   vtxaddr->x = x;
   vtxaddr->y = y;
   vtxaddr->z = -z;

    return (1);
}

/*** function to read model edge from input file */

int get_model_edge(inline1)
char *inline1;
{
   int ident, numarg, iplot, ireflmode;
   int vtx1, vtx2;
   struct edge *edgeaddr;
   struct vertex *vtxaddr;

   if ((numarg =
         sscanf(inline1, "%d %d %d %d %d",
         &ident, &vtx1, &vtx2, &iplot, &ireflmode)) < 3)
       return (-1);

   if (numarg < 4)
      iplot = 1;

   if (numarg < 5)
      ireflmode = 0;

   if ((edgeaddr = addedge(ident)) == NULL)
       return (-2);
   num_edge++;
   edgeaddr->id_edge = ident;
   edgeaddr->edge_plot = iplot;
   edgeaddr->refl_mode = ireflmode;

      /* find addresses of edge vertices */

   edgeaddr->v1 = edgeaddr->v2 = NULL;
   vtxaddr = vtx_head;
    do {
      if (vtxaddr->id_vtx == vtx1)
         edgeaddr->v1 = vtxaddr;
      if (vtxaddr->id_vtx == vtx2)
         edgeaddr->v2 = vtxaddr;
      vtxaddr = vtxaddr->next;
   } while (vtxaddr != vtx_head &&
      (edgeaddr->v1 == NULL || edgeaddr->v2 == NULL));

   if (edgeaddr->v1 == NULL)
      fprintf(stderr, "Error cannot find vertex %d.\n", vtx1);
   if (edgeaddr->v2 == NULL)
      fprintf(stderr, "Error cannot find vertex %d.\n", vtx2);

    return (1);
}



/*** function to read model 2-D polygon from input file */

int get_model_poly(inline1, fp)
char *inline1;
FILE *fp;
{
   int ident, num_edges, nedge, id_edge;
   double ref, vpref, vpgrad, vsref, vsgrad, denref, dengrad;
   struct edge *edgeaddr;
   struct polygon *polyaddr;

   if ((sscanf(inline1, "%d %d %lf %lf %lf %lf %lf %lf %lf",
         &ident, &num_edges,
         &ref, &vpref, &vpgrad, &vsref, &vsgrad, &denref, &dengrad)) != 9)
       return (-1);

      /* skip rest of input and return if in 3D mode */

   if (prog_mode_3d) {
      for (nedge = 0;
         nedge < num_edges, fscanf(fp, "%d", &id_edge); nedge++) ;
       return (0);
   }

   if (num_edges < 3)
      fprintf(stderr,
         "Warning polygon %d has less than 3 edges!\n", ident);
      

      /* add polygon structure to polygon list */

   if ((polyaddr = addpoly(ident)) == NULL)
       return (-2);
   num_poly++;
   polyaddr->id_poly = ident;
   polyaddr->n_edges = num_edges;
   polyaddr->ref = ref;
   polyaddr->vpref = vpref;
   polyaddr->vpgrad = vpgrad;
   polyaddr->vsref = vsref;
   polyaddr->vsgrad = vsgrad;
   polyaddr->denref = denref;
   polyaddr->dengrad = dengrad;
         
      /* allocate space for edge pointer array */

   if ((polyaddr->edges = (struct edge **)
         malloc((size_t) num_edges * sizeof(struct edge *))) == NULL)
      return(-3);

      /* read and find addresses of edges */

   for (nedge = 0; nedge < num_edges; nedge++) {
      if ((fscanf(fp, "%d", &id_edge)) != 1)
          return (-4);
      polyaddr->edges[nedge] = NULL;
      edgeaddr = edge_head;
          do {
         if (edgeaddr->id_edge == id_edge)
         polyaddr->edges[nedge] = edgeaddr;
         edgeaddr = edgeaddr->next;
      } while (edgeaddr != edge_head && polyaddr->edges[nedge] == NULL);

      if (edgeaddr->v1 == NULL)
         fprintf(stderr, "Error cannot find edge %d.\n", id_edge);
   }

      /* set edge normals */

   set_poly_normals(polyaddr);

      /* set polygon x, y and z limits */

   set_poly_limits(polyaddr);

    return (1);
}



/*** function to read model 3-D polygon from input file */

int get_model_poly_3d(inline1, fp)
char *inline1;
FILE *fp;
{
   int ident, num_edges, nedge, id_edge;
   struct edge *edgeaddr;
   struct polygon *polyaddr;

   if ((sscanf(inline1, "%d %d",
         &ident, &num_edges)) != 2)
       return (-1);

      /* skip rest of input and return if in 2D mode */

   if (! prog_mode_3d) {
      for (nedge = 0;
         nedge < num_edges, fscanf(fp, "%d", &id_edge); nedge++) ;
       return (0);
   }

   if (num_edges < 3)
      fprintf(stderr,
         "Warning polygon %d has less than 3 edges!\n", ident);
      
      /* add polygon structure to polygon list */

   if ((polyaddr = addpoly(ident)) == NULL)
       return (-2);
   num_poly++;
   polyaddr->id_poly = ident;
   polyaddr->n_edges = num_edges;
         
      /* allocate space for edge pointer array */

   if ((polyaddr->edges = (struct edge **)
         malloc((size_t) num_edges * sizeof(struct edge *))) == NULL)
      return(-3);

      /* read and find addresses of edges */

   for (nedge = 0; nedge < num_edges; nedge++) {
      if ((fscanf(fp, "%d", &id_edge)) != 1)
          return (-4);
      polyaddr->edges[nedge] = NULL;
      edgeaddr = edge_head;
          do {
         if (edgeaddr->id_edge == id_edge)
         polyaddr->edges[nedge] = edgeaddr;
         edgeaddr = edgeaddr->next;
      } while (edgeaddr != edge_head && polyaddr->edges[nedge] == NULL);

      if (polyaddr->edges[nedge] == NULL)
         fprintf(stderr, "Error cannot find edge %d.\n", id_edge);
   }

      /* set polygon x, y and z limits */

   set_poly_limits(polyaddr);

    return (1);
}


/*** function to read model 3-D solid from input file */

int get_model_solid(inline1, fp)
char *inline1;
FILE *fp;
{
   int ident, num_poly, npoly, id_poly;
   double ref, vpref, vpgrad, vsref, vsgrad, denref, dengrad;
   struct polygon *polyaddr;
   struct solid *solidaddr;
   int num;
   double qpref, qsref, qwref;

/*
   if ((sscanf(inline1, "%d %d %lf %lf %lf %lf %lf %lf %lf",
         &ident, &num_poly,
         &ref, &vpref, &vpgrad, &vsref, &vsgrad, &denref, &dengrad)) != 9)
       return (-1);
*/
   qpref = -1.;
   qsref = -1.;
   qwref = -1.;
   num = sscanf(inline1, "%d %d %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf",
         &ident, &num_poly,
         &ref, &vpref, &vpgrad, &vsref, &vsgrad, &denref, &dengrad, 
         &qpref, &qsref, &qwref);
   if (num < 9 || num > 12) return(-1);

      /* skip rest of input and return if in 2D mode */

   if (! prog_mode_3d) {
      for (npoly = 0;
         npoly < num_poly, fscanf(fp, "%d", &id_poly); npoly++);
       return (0);
   }

   if (num_poly < 4)
      fprintf(stderr,
         "Warning solid %d has less than 3 polygons!\n", ident);
      

      /* add solid structure to solid list */

   if ((solidaddr = addsolid(ident)) == NULL)
       return (-2);
   num_solid++;
   solidaddr->id_solid = ident;
   solidaddr->n_poly = num_poly;
   solidaddr->ref = ref;
   solidaddr->vpref = vpref;
   solidaddr->vpgrad = vpgrad;
   solidaddr->vsref = vsref;
   solidaddr->vsgrad = vsgrad;
   solidaddr->denref = denref;
   solidaddr->dengrad = dengrad;
   solidaddr->qpref   = qpref;  
   solidaddr->qsref   = qsref;  
   solidaddr->qwref   = qwref;  
         
      /* allocate space for polygon pointer array */

   if ((solidaddr->poly = (struct polygon **)
         malloc((size_t) num_poly * sizeof(struct polygon *))) == NULL)
      return(-3);

      /* read and find addresses of polygons */

   for (npoly = 0; npoly < num_poly; npoly++) {
      if ((fscanf(fp, "%d", &id_poly)) != 1)
          return (-4);
      solidaddr->poly[npoly] = NULL;
      polyaddr = poly_head;
         do {
         if (polyaddr->id_poly == id_poly)
            solidaddr->poly[npoly] = polyaddr;
         polyaddr = polyaddr->next;
      } while (polyaddr != poly_head && solidaddr->poly[npoly] == NULL);

      if (solidaddr->poly[npoly] == NULL)
         fprintf(stderr, "Error cannot find poly %d.\n", id_poly);
   }

      /* set polygon normals */

   set_solid_normals(solidaddr);

      /* set solid x, y and z limits */

   set_solid_limits(solidaddr);

    return (1);
}


/*** function to add a new element to vertex list */
/* (double-thread, circular linked list) */

struct vertex *
addvtx(id_num)
int id_num;
{

    struct vertex *addr;

    addr = (struct vertex *) malloc(sizeof(struct vertex));
    if (addr == NULL) {
      puterr("Error adding vertex, no memory?");
      return(addr);
    }

    if (vtx_head == NULL) {      /* no elements in list */
      vtx_head = addr->next = addr->prev = addr;
    } else {               /* add new element to end of list */
      addr->prev = vtx_head->prev;
      addr->next = vtx_head;
      addr->next->prev = addr;
      addr->prev->next = addr;
    }

    return(addr);
}


/*** function to add a new element to edge list */
/* (double-thread, circular linked list) */

struct edge *
addedge(id_num)
int id_num;
{

    struct edge *addr;

    addr = (struct edge *) malloc(sizeof(struct edge));
    if (addr == NULL) {
      puterr("Error adding edge, no memory?");
      return(addr);
    }

    if (edge_head == NULL) {      /* no elements in list */
      edge_head = addr->next = addr->prev = addr;
    } else {               /* add new element to end of list */
      addr->prev = edge_head->prev;
      addr->next = edge_head;
      addr->next->prev = addr;
      addr->prev->next = addr;
    }

    return(addr);
}


/*** function to add a new element to polygon list */
/* (double-thread, circular linked list) */

struct polygon *
addpoly(id_num)
int id_num;
{

    struct polygon *addr;

    addr = (struct polygon *) malloc(sizeof(struct polygon));
    if (addr == NULL) {
      puterr("Error adding polygon, no memory?");
      return(addr);
    }

    if (poly_head == NULL) {      /* no elements in list */
      poly_head = addr->next = addr->prev = addr;
    } else {               /* add new element to end of list */
      addr->prev = poly_head->prev;
      addr->next = poly_head;
      addr->next->prev = addr;
      addr->prev->next = addr;
    }

    return(addr);
}


/*** function to add a new element to solid list */
/* (double-thread, circular linked list) */

struct solid *
addsolid(id_num)
int id_num;
{

    struct solid *addr;

    addr = (struct solid *) malloc(sizeof(struct solid));
    if (addr == NULL) {
      puterr("Error adding solid, no memory?");
      return(addr);
    }

    if (solid_head == NULL) {      /* no elements in list */
      solid_head = addr->next = addr->prev = addr;
    } else {               /* add new element to end of list */
      addr->prev = solid_head->prev;
      addr->next = solid_head;
      addr->next->prev = addr;
      addr->prev->next = addr;
    }

    return(addr);
}


/*** function to display model vertices */

int disp_vertices()
{
   struct vertex *addr;

   if ((addr = vtx_head) == NULL) {
      printf("VERTEX  No vertices read.\n");
      return(0);
   }

   printf("VERTICES (%d read)\n  ", num_vtx);
   do {
      printf("v%d:{%.2f,%.2f}  ", addr->id_vtx, addr->x, addr->z);
   } while ((addr = addr->next) != vtx_head);
   printf("\n");

   return(0);

}


/*** function to display model edges */

int disp_edges()
{
   struct edge *addr;

   if ((addr = edge_head) == NULL) {
      printf("EDGE  No edges read.\n");
      return(0);
   }

   printf("EDGES (%d read)\n  ", num_edge);
   do {
      printf("e%d:{v%d,v%d}p%d,r%d  ",
         addr->id_edge, addr->v1->id_vtx, addr->v2->id_vtx,
         addr->edge_plot, addr->refl_mode);
   } while ((addr = addr->next) != edge_head);
   printf("\n");

   return(0);

}


/*** function to display model polygons */

int disp_polygons()
{
   int nedge;
   struct polygon *addr;

   if ((addr = poly_head) == NULL) {
      printf("   POLYGON  No polygons read.\n");
      return(0);
   }

   printf("POLYGON (%d read)\n", num_poly);

   do {
      printf("  %d : ", addr->id_poly);
      if (! prog_mode_3d) {
         printf("ref_level=%5.2lf\n", addr->ref);
         printf("    Vp=%5.3lf dV=%6.4lf Vs=%5.3lf dV=%6.4lf",
                addr->vpref, addr->vpgrad, addr->vsref, addr->vsgrad);
         printf(" Den=%5.2lf dDen=%6.4lf\n", addr->denref, addr->dengrad);
      }
      printf("    {");
      for (nedge = 0; nedge < addr->n_edges; nedge++) {
         if (nedge > 0)
            printf(", ");
         printf("e%d", addr->edges[nedge]->id_edge);
      }
      printf("}\n");
   } while ((addr = addr->next) != poly_head);

   return(0);

}



/*** function to display model solids */

int disp_solids()
{
   int npoly;
   struct solid *addr;

   if ((addr = solid_head) == NULL) {
      printf("   SOLID  No solids read.\n");
      return(0);
   }

   printf("SOLID (%d read)\n", num_solid);

   do {
      printf("  %d : ", addr->id_solid);
      printf("ref_level=%5.2lf\n", addr->ref);
      printf("    Vp=%5.3lf dV=%6.4lf Vs=%5.3lf dV=%6.4lf",
          addr->vpref, addr->vpgrad, addr->vsref, addr->vsgrad);
      printf(" Den=%5.2lf dDen=%6.4lf\n", addr->denref, addr->dengrad);
      printf("    {");
      for (npoly = 0; npoly < addr->n_poly; npoly++) {
         if (npoly > 0)
            printf(", ");
         printf("p%d", addr->poly[npoly]->id_poly);
      }
      printf("}\n");
   } while ((addr = addr->next) != solid_head);

   return(0);

}


/*** function to set normals to edges */
/*     Normals are used to determine if a point is inside polygon */
/*      if eq. of line is F(x,y) = Ax - By + C = 0, then point is to one side
      of the line or the other if F(x,y) > or < 0.
      This function determines A, B and C so that 
      points inside the polygon will satisfy F(x,y) >= 0.
*/

int set_poly_normals(addr)
struct polygon *addr;
{
   int nedge, nedge_test;
   double x1, z1, x2, z2, xtest, ztest;
   double a, b, c;
   struct vertex *vaddr1, *vaddr2, *vaddr_test;

      /* allocate space for normal coeff structures */

      if ((addr->norm = (struct normals *)
         malloc(addr->n_edges * sizeof(struct normals))) == NULL)
      puterr("Error allocating normals memory.");

      /* set normals for each edge */

   for (nedge = 0; nedge < addr->n_edges; nedge++) {

         /* determine coefficents */

      vaddr1 = addr->edges[nedge]->v1;
      x1 = vaddr1->x;
      z1 = vaddr1->z;
      vaddr2 = addr->edges[nedge]->v2;
      x2 = vaddr2->x;
      z2 = vaddr2->z;
      if (x1 == x2) {
         a = 1.0;
         b = 0.0;
         c = -x1;
      } else {
         a = (z1 - z2) / (x1 - x2);
         b = -1;
         c = z1 - a * x1;
      }

         /* find test vertex not on current edge */

      if ((nedge_test = nedge + 1) >= addr->n_edges)
         nedge_test = 0;
      vaddr_test = addr->edges[nedge_test]->v1;
      if ((vaddr1->id_vtx == vaddr_test->id_vtx) ||
            (vaddr2->id_vtx == vaddr_test->id_vtx))
         vaddr_test = addr->edges[nedge_test]->v2;
      xtest = vaddr_test->x;
      ztest = vaddr_test->z;

         /* adjust coeff so test vertex gives > 0 in line eq. */
 
      if ((a * xtest + b * ztest + c) < 0.0) {
         a = -a; b = -b; c = -c;
      }

         /* store coeff */

      addr->norm[nedge].a = a;
      addr->norm[nedge].b = b;
      addr->norm[nedge].c = c;

      printf("EDGE NORM p%d e%d  %f %f %f\n", addr->id_poly,
         addr->edges[nedge]->id_edge, a, b, c);

   }

   return(0);


}

/*** function to set normals to polygons */
/*     Normals are used to determine if a point is inside solid */
/*      if eq. of polygon is F(x,y) = Ax + By + Cz + D = 0, then point
      is to one side of the line or the other if F(x,y) > or < 0.
      This function determines A, B, C and D so that 
      points inside the solid will satisfy F(x,y) >= 0.
*/

int set_solid_normals(addr)
struct solid *addr;
{
   int npoly, npoly_test;
   int nedge, nedge_test, nedge_curr;
   double x1, y1, z1, x2, y2, z2, x3, y3, z3, xtest, ytest, ztest;
   double a, b, c, d;
   struct vertex *vaddr1, *vaddr2, *vaddr3, *vaddr_test, *vaddr_curr;

      /* allocate space for normal coeff structures */

      if ((addr->norm = (struct normals *)
         malloc(addr->n_poly * sizeof(struct normals))) == NULL)
      puterr("Error allocating normals memory.");

      /* set normals for each polygon */

   for (npoly = 0; npoly < addr->n_poly; npoly++) {

         /* select 3 vertices from polygon edges */

      vaddr1 = addr->poly[npoly]->edges[1]->v1;
      vaddr2 = addr->poly[npoly]->edges[1]->v2;
      vaddr3 = addr->poly[npoly]->edges[2]->v1;
      if (vaddr3 == vaddr2 || vaddr3 == vaddr1)
         vaddr3 = addr->poly[npoly]->edges[2]->v2;

         /* determine coefficents */

      x1 = vaddr1->x;
      y1 = vaddr1->y;
      z1 = vaddr1->z;
      x2 = vaddr2->x;
      y2 = vaddr2->y;
      z2 = vaddr2->z;
      x3 = vaddr3->x;
      y3 = vaddr3->y;
      z3 = vaddr3->z;

      a = y1 * (z2 - z3) + y2 * (z3 - z1) + y3 * (z1 - z2);
      b = z1 * (x2 - x3) + z2 * (x3 - x1) + z3 * (x1 - x2);
      c = x1 * (y2 - y3) + x2 * (y3 - y1) + x3 * (y1 - y2);
      d = - x1 * (y2 * z3 - y3 * z2)
         - x2 * (y3 * z1 - y1 * z3)
         - x3 * (y1 * z2 - y2 * z1);

         /* find test vertex not on current polygon */

      for (npoly_test = 0; npoly_test < addr->n_poly; npoly_test++) {

         for (nedge_test = 0;
            nedge_test < addr->poly[npoly_test]->n_edges; nedge_test++) {

            vaddr_test = addr->poly[npoly_test]->edges[nedge_test]->v1;

            for (nedge_curr = 0;
               nedge_curr < addr->poly[npoly]->n_edges; nedge_curr++) {

               vaddr_curr = addr->poly[npoly]->edges[nedge_curr]->v1;
               if (vaddr_curr->id_vtx == vaddr_test->id_vtx)
                  goto fail1;
               vaddr_curr = addr->poly[npoly]->edges[nedge_curr]->v2;
               if (vaddr_curr->id_vtx == vaddr_test->id_vtx)
                  goto fail1;
            }
            goto test_exit;
            fail1:

            vaddr_test = addr->poly[npoly_test]->edges[nedge_test]->v2;

            for (nedge_curr = 0;
               nedge_curr < addr->poly[npoly]->n_edges; nedge_curr++) {

               vaddr_curr = addr->poly[npoly]->edges[nedge_curr]->v1;
               if (vaddr_curr->id_vtx == vaddr_test->id_vtx)
                  goto fail2;
               vaddr_curr = addr->poly[npoly]->edges[nedge_curr]->v2;
               if (vaddr_curr->id_vtx == vaddr_test->id_vtx)
                  goto fail2;
            }
            goto test_exit;
            fail2:
            continue;
         }
      }

      fprintf(stderr, "Error - test vertex not found.");

      test_exit:

      xtest = vaddr_test->x;
      ytest = vaddr_test->y;
      ztest = vaddr_test->z;

         /* adjust coeff so test vertex gives > 0 in line eq. */
 
      if ((a * xtest + b * ytest + c * ztest + d) < 0.0) {
         a = -a; b = -b; c = -c; d = -d;
      }

         /* store coeff */

      addr->norm[npoly].a = a;
      addr->norm[npoly].b = b;
      addr->norm[npoly].c = c;
      addr->norm[npoly].d = d;

/*      printf("POLY NORM s%d p%d  %f %f %f %f\n", addr->id_solid,
         addr->poly[npoly]->id_poly, a, b, c, d); */

   }

   return(0);


}

/*** function to set polygon limits */

int set_poly_limits(addr)
struct polygon *addr;
{
   int nedge;
   double xmin, ymin, zmin, xmax, ymax, zmax, temp;

   xmin = ymin = zmin = REAL_MAX;
   xmax = ymax = zmax = -REAL_MAX;

      /* check limits for each vertex of each edge */

   for (nedge = 0; nedge < addr->n_edges; nedge++) {
      if ((temp = addr->edges[nedge]->v1->x) > xmax)
         xmax = temp;
      if (temp < xmin)
         xmin = temp;
      if ((temp = addr->edges[nedge]->v2->x) > xmax)
         xmax = temp;
      if (temp < xmin)
         xmin = temp;
      if ((temp = addr->edges[nedge]->v1->y) > ymax)
         ymax = temp;
      if (temp < ymin)
         ymin = temp;
      if ((temp = addr->edges[nedge]->v2->y) > ymax)
         ymax = temp;
      if (temp < ymin)
         ymin = temp;
      if ((temp = addr->edges[nedge]->v1->z) > zmax)
         zmax = temp;
      if (temp < zmin)
         zmin = temp;
      if ((temp = addr->edges[nedge]->v2->z) > zmax)
         zmax = temp;
      if (temp < zmin)
         zmin = temp;
   }

   addr->xmin = xmin;
   addr->xmax = xmax;
   addr->ymin = ymin;
   addr->ymax = ymax;
   addr->zmin = zmin;
   addr->zmax = zmax;

/*   printf("POLY LIMITS p%d  x %f %f  y %f %f  z %f %f\n", addr->id_poly,
      xmin, xmax, ymin, ymax, zmin, zmax); */

   return(0);

}


/*** function to set solid limits */

int set_solid_limits(addr)
struct solid *addr;
{
   int npoly;
   double xmin, ymin, zmin, xmax, ymax, zmax, temp;

   xmin = ymin = zmin = REAL_MAX;
   xmax = ymax = zmax = -REAL_MAX;

      /* check limits for each polygon */

   for (npoly = 0; npoly < addr->n_poly; npoly++) {
      if ((temp = addr->poly[npoly]->xmax) > xmax)
         xmax = temp;
      if ((temp = addr->poly[npoly]->xmin) < xmin)
         xmin = temp;
      if ((temp = addr->poly[npoly]->ymax) > ymax)
         ymax = temp;
      if ((temp = addr->poly[npoly]->ymin) < ymin)
         ymin = temp;
      if ((temp = addr->poly[npoly]->zmax) > zmax)
         zmax = temp;
      if ((temp = addr->poly[npoly]->zmin) < zmin)
         zmin = temp;
   }

   addr->xmin = xmin;
   addr->xmax = xmax;
   addr->ymin = ymin;
   addr->ymax = ymax;
   addr->zmin = zmin;
   addr->zmax = zmax;

/* shawn
   printf("SOLID LIMITS s%d  x %f %f  y %f %f  z %f %f\n", addr->id_solid,
      xmin, xmax, ymin, ymax, zmin, zmax);
*/

   return(0);

}


/*** function to calculate velocity from polygon model */
 
double get_poly_vel(xpos, zpos, wavetype, den, iden, imodel)  
double xpos, zpos;
char wavetype;
double *den;
int iden;
int *imodel;
{
    int n;
    double vel;

   struct polygon *addr;
   
    if (zpos > 0.0)
      zpos = -zpos;     /* reflect point above surface */

   if ((addr = poly_head) == NULL) {
      return(-1.0);
   }

   do {
      if (xpos >= addr->xmin && xpos <= addr->xmax &&
         zpos >= addr->zmin && zpos <= addr->zmax) {

         if (inside_poly(xpos, zpos, addr)) {

            if (wavetype == 'P')
               vel = addr->vpref +
                  addr->vpgrad * (addr->ref - zpos);
            else
               vel = addr->vsref +
                  addr->vsgrad * (addr->ref - zpos);

             if (iden == 1)
               *den = addr->denref +
                  addr->dengrad * (addr->ref - zpos);

               /* set model element code */

            *imodel = addr->id_poly;

            return(vel);
         }
      }
   } while ((addr = addr->next) != poly_head);

    return(-1.0);
}


/*** function to determine if a point is inside a simple polygon */

int inside_poly(xpt, zpt, addr)
double xpt, zpt;
struct polygon *addr;
{
   int nedge;
   
   for (nedge = 0; nedge < addr->n_edges; nedge++) {
/*      printf("TEST e%d x %f y %f test=%f\n", addr->edges[nedge]->id_edge, 
         xpt, zpt,
         xpt * addr->norm[nedge].a + zpt * addr->norm[nedge].b +
         addr->norm[nedge].c);
*/
      if (xpt * addr->norm[nedge].a + zpt * addr->norm[nedge].b +
            addr->norm[nedge].c < 0.0)
         return(0);
   }

   return(1);
}


/*** function to calculate velocity from polygon model */
 
double get_solid_vel(xpos, ypos, zpos, wavetype, den, iden, qp, qs, qw, imodel)
double xpos, ypos, zpos;
char wavetype;
double *den;
int iden, *imodel;
double *qp, *qs, *qw;
{
    int n;

    double vel;
   struct solid *addr;
   
    if (zpos > 0.0)
      zpos = -zpos;     /* reflect point above surface */

   if ((addr = solid_head) == NULL) {
      return(-1.0);
   }

   do {
      if (xpos >= addr->xmin && xpos <= addr->xmax &&
            ypos >= addr->ymin && ypos <= addr->ymax &&
            zpos >= addr->zmin && zpos <= addr->zmax) {
         if (inside_solid(xpos, ypos, zpos, addr)) {
            if (wavetype == 'P')
               vel = addr->vpref +
                  addr->vpgrad * (addr->ref - zpos);
            else
               vel = addr->vsref +
                  addr->vsgrad * (addr->ref - zpos);
             if (iden == 1)
               *den = addr->denref +
                  addr->dengrad * (addr->ref - zpos);
            *qp = addr->qpref;   
            *qs = addr->qsref;   
            *qw = addr->qwref;   
            *imodel = SOLIDOFFSET + addr->id_solid;
            return(vel);
         }
      }
   } while ((addr = addr->next) != solid_head);

    return(-1.0);
}


/*** function to determine if a point is inside a simple solid */

int inside_solid(xpt, ypt, zpt, addr)
double xpt, ypt, zpt;
struct solid *addr;
{
   int npoly;
   
   for (npoly = 0; npoly < addr->n_poly; npoly++) {
/*      printf("TEST p%d x %f y %f z %f test=%f\n", addr->poly[npoly]->id_poly, 
         xpt, ypt, zpt,
         xpt * addr->norm[npoly].a + ypt * addr->norm[npoly].b +
         zpt * addr->norm[npoly].c +
         addr->norm[npoly].d);*/

      if (xpt * addr->norm[npoly].a + ypt * addr->norm[npoly].b +
            zpt * addr->norm[npoly].c  + addr->norm[npoly].d < 0.0)
         return(0);
   }

   return(1);
}




