/****************************************************************************
This file contains parameters for readline.

author: shawn larsen
date:   march 1988  
where:  caltech
****************************************************************************/



/***************
LINE TYPE VALUES
***************/

#define LINE_FOUND    1 /* readLine: non-null line                           */
#define FILE_END      0 /* readLine: EOF encountered with readLine           */
#define LINE_END     -1 /* readLine: EOF encountered on coninuation line (\) */

#define LINE_COMMENT -2 /* readLine/getLine: hard comment (# 1st non-white)  */

#define LINE_NULL    -3 /* getLine: null line ('\0' as first character)      */
#define LINE_BLANK   -4 /* getLine: blank line (all ' ' or '\t' before '\n') */
#define LINE_VALUE   -5 /* getLine: numeric 1st non-white (0-9, +, -, ., \)  */
#define LINE_PAR     -6 /* getLine: parameter line (parameter=value)         */
#define LINE_UNKNOWN -9 /* getLine: unknown line type                        */



/*************
MAXIMUM LIMITS
*************/

#define MAX_LINE_TYPES   100
#define MAX_LINE_ARG      50
#define STRING_SIZE      514
#define MAX_FILE_LINES 20000



/*********************
LINKED-LIST STRUCTURES
*********************/

struct line_list {
         char                   *line;  /* pointer to current line      */
         struct       line_list *prev;  /* pointer to prev list element */
         struct       line_list *next;  /* pointer to next list element */
         int                     type;  /* line type of current element */
         };

typedef struct   line_list LinkList;
