/****************************************************************************
This file contains usage strings for elastic finite difference programs

author: shawn larsen
date:   march 1991
where:  caltech
****************************************************************************/

#include <sys/types.h>
#include <sys/stat.h>

#define REGULAR_FILE 0100000
#define PIPE         0010000


/*************
USAGE FOR ELAS 
*************/

char *elasUsage[] = {
   "Usage:  e3d [-v] [inputFile | < inputFile]\n",
   "\n",
   "Example 2D Input File:\n",
   "---------------------\n",
   "\n",
   "grid       m=200 l=50 n=100 dh=0.0020\n",
   "time       dt=0.000300 t=2000\n",
   "source     type=1 freq=0.5 amp=1.e22 t0=0.025 m=50 n=50\n",
   "source     type=1 freq=0.5 amp=1.e22 t0=0.025 m=50 n=75\n",
   "visual     movie=2 scale=3.0\n",
   "sac        file=\"sacxz\" m=0 n=10\n",
   "sac        file=\"sacxz\" m=0 n=20\n",
   "block      p=4.0 s=2.309 r=3.0\n",
   "block      p=4.0 s=2.309 r=3.0 m1=0 m2=100\n",
   NULL,
   };

